<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html lang="en">
<head>
<title>Source code</title>
<link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
</head>
<body>
<div class="sourceContainer">
<pre><span class="sourceLineNo">001</span>/*<a name="line.1"></a>
<span class="sourceLineNo">002</span> * Licensed to the Apache Software Foundation (ASF) under one or more<a name="line.2"></a>
<span class="sourceLineNo">003</span> * contributor license agreements.  See the NOTICE file distributed with<a name="line.3"></a>
<span class="sourceLineNo">004</span> * this work for additional information regarding copyright ownership.<a name="line.4"></a>
<span class="sourceLineNo">005</span> * The ASF licenses this file to You under the Apache License, Version 2.0<a name="line.5"></a>
<span class="sourceLineNo">006</span> * (the "License"); you may not use this file except in compliance with<a name="line.6"></a>
<span class="sourceLineNo">007</span> * the License.  You may obtain a copy of the License at<a name="line.7"></a>
<span class="sourceLineNo">008</span> *<a name="line.8"></a>
<span class="sourceLineNo">009</span> *   http://www.apache.org/licenses/LICENSE-2.0<a name="line.9"></a>
<span class="sourceLineNo">010</span> *<a name="line.10"></a>
<span class="sourceLineNo">011</span> * Unless required by applicable law or agreed to in writing, software<a name="line.11"></a>
<span class="sourceLineNo">012</span> * distributed under the License is distributed on an "AS IS" BASIS,<a name="line.12"></a>
<span class="sourceLineNo">013</span> * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.<a name="line.13"></a>
<span class="sourceLineNo">014</span> * See the License for the specific language governing permissions and<a name="line.14"></a>
<span class="sourceLineNo">015</span> * limitations under the License.<a name="line.15"></a>
<span class="sourceLineNo">016</span> *<a name="line.16"></a>
<span class="sourceLineNo">017</span> */<a name="line.17"></a>
<span class="sourceLineNo">018</span><a name="line.18"></a>
<span class="sourceLineNo">019</span>package org.apache.commons.dbcp2;<a name="line.19"></a>
<span class="sourceLineNo">020</span><a name="line.20"></a>
<span class="sourceLineNo">021</span>import java.sql.Connection;<a name="line.21"></a>
<span class="sourceLineNo">022</span>import java.sql.ResultSet;<a name="line.22"></a>
<span class="sourceLineNo">023</span>import java.sql.Statement;<a name="line.23"></a>
<span class="sourceLineNo">024</span>import java.text.MessageFormat;<a name="line.24"></a>
<span class="sourceLineNo">025</span>import java.util.HashSet;<a name="line.25"></a>
<span class="sourceLineNo">026</span>import java.util.Properties;<a name="line.26"></a>
<span class="sourceLineNo">027</span>import java.util.ResourceBundle;<a name="line.27"></a>
<span class="sourceLineNo">028</span>import java.util.Set;<a name="line.28"></a>
<span class="sourceLineNo">029</span><a name="line.29"></a>
<span class="sourceLineNo">030</span>/**<a name="line.30"></a>
<span class="sourceLineNo">031</span> * Utility methods.<a name="line.31"></a>
<span class="sourceLineNo">032</span> *<a name="line.32"></a>
<span class="sourceLineNo">033</span> * @since 2.0<a name="line.33"></a>
<span class="sourceLineNo">034</span> */<a name="line.34"></a>
<span class="sourceLineNo">035</span>public final class Utils {<a name="line.35"></a>
<span class="sourceLineNo">036</span><a name="line.36"></a>
<span class="sourceLineNo">037</span>    private static final ResourceBundle messages = ResourceBundle<a name="line.37"></a>
<span class="sourceLineNo">038</span>        .getBundle(Utils.class.getPackage().getName() + ".LocalStrings");<a name="line.38"></a>
<span class="sourceLineNo">039</span><a name="line.39"></a>
<span class="sourceLineNo">040</span>    /**<a name="line.40"></a>
<span class="sourceLineNo">041</span>     * Whether the security manager is enabled.<a name="line.41"></a>
<span class="sourceLineNo">042</span>     */<a name="line.42"></a>
<span class="sourceLineNo">043</span>    public static final boolean IS_SECURITY_ENABLED = System.getSecurityManager() != null;<a name="line.43"></a>
<span class="sourceLineNo">044</span><a name="line.44"></a>
<span class="sourceLineNo">045</span>    /** Any SQL_STATE starting with this value is considered a fatal disconnect */<a name="line.45"></a>
<span class="sourceLineNo">046</span>    public static final String DISCONNECTION_SQL_CODE_PREFIX = "08";<a name="line.46"></a>
<span class="sourceLineNo">047</span><a name="line.47"></a>
<span class="sourceLineNo">048</span>    /**<a name="line.48"></a>
<span class="sourceLineNo">049</span>     * SQL codes of fatal connection errors.<a name="line.49"></a>
<span class="sourceLineNo">050</span>     * &lt;ul&gt;<a name="line.50"></a>
<span class="sourceLineNo">051</span>     * &lt;li&gt;57P01 (Admin shutdown)&lt;/li&gt;<a name="line.51"></a>
<span class="sourceLineNo">052</span>     * &lt;li&gt;57P02 (Crash shutdown)&lt;/li&gt;<a name="line.52"></a>
<span class="sourceLineNo">053</span>     * &lt;li&gt;57P03 (Cannot connect now)&lt;/li&gt;<a name="line.53"></a>
<span class="sourceLineNo">054</span>     * &lt;li&gt;01002 (SQL92 disconnect error)&lt;/li&gt;<a name="line.54"></a>
<span class="sourceLineNo">055</span>     * &lt;li&gt;JZ0C0 (Sybase disconnect error)&lt;/li&gt;<a name="line.55"></a>
<span class="sourceLineNo">056</span>     * &lt;li&gt;JZ0C1 (Sybase disconnect error)&lt;/li&gt;<a name="line.56"></a>
<span class="sourceLineNo">057</span>     * &lt;/ul&gt;<a name="line.57"></a>
<span class="sourceLineNo">058</span>     */<a name="line.58"></a>
<span class="sourceLineNo">059</span>    public static final Set&lt;String&gt; DISCONNECTION_SQL_CODES;<a name="line.59"></a>
<span class="sourceLineNo">060</span><a name="line.60"></a>
<span class="sourceLineNo">061</span>    static {<a name="line.61"></a>
<span class="sourceLineNo">062</span>        DISCONNECTION_SQL_CODES = new HashSet&lt;&gt;();<a name="line.62"></a>
<span class="sourceLineNo">063</span>        DISCONNECTION_SQL_CODES.add("57P01"); // Admin shutdown<a name="line.63"></a>
<span class="sourceLineNo">064</span>        DISCONNECTION_SQL_CODES.add("57P02"); // Crash shutdown<a name="line.64"></a>
<span class="sourceLineNo">065</span>        DISCONNECTION_SQL_CODES.add("57P03"); // Cannot connect now<a name="line.65"></a>
<span class="sourceLineNo">066</span>        DISCONNECTION_SQL_CODES.add("01002"); // SQL92 disconnect error<a name="line.66"></a>
<span class="sourceLineNo">067</span>        DISCONNECTION_SQL_CODES.add("JZ0C0"); // Sybase disconnect error<a name="line.67"></a>
<span class="sourceLineNo">068</span>        DISCONNECTION_SQL_CODES.add("JZ0C1"); // Sybase disconnect error<a name="line.68"></a>
<span class="sourceLineNo">069</span>    }<a name="line.69"></a>
<span class="sourceLineNo">070</span><a name="line.70"></a>
<span class="sourceLineNo">071</span>    /**<a name="line.71"></a>
<span class="sourceLineNo">072</span>     * Clones the given char[] if not null.<a name="line.72"></a>
<span class="sourceLineNo">073</span>     *<a name="line.73"></a>
<span class="sourceLineNo">074</span>     * @param value may be null.<a name="line.74"></a>
<span class="sourceLineNo">075</span>     * @return a cloned char[] or null.<a name="line.75"></a>
<span class="sourceLineNo">076</span>     */<a name="line.76"></a>
<span class="sourceLineNo">077</span>    public static char[] clone(final char[] value) {<a name="line.77"></a>
<span class="sourceLineNo">078</span>        return value == null ? null : value.clone();<a name="line.78"></a>
<span class="sourceLineNo">079</span>    }<a name="line.79"></a>
<span class="sourceLineNo">080</span><a name="line.80"></a>
<span class="sourceLineNo">081</span>    /**<a name="line.81"></a>
<span class="sourceLineNo">082</span>     * Clones the given {@link Properties} without the standard "user" or "password" entries.<a name="line.82"></a>
<span class="sourceLineNo">083</span>     * <a name="line.83"></a>
<span class="sourceLineNo">084</span>     * @param properties may be null<a name="line.84"></a>
<span class="sourceLineNo">085</span>     * @return a clone of the input without the standard "user" or "password" entries.<a name="line.85"></a>
<span class="sourceLineNo">086</span>     * @since 2.8.0<a name="line.86"></a>
<span class="sourceLineNo">087</span>     */<a name="line.87"></a>
<span class="sourceLineNo">088</span>    public static Properties cloneWithoutCredentials(final Properties properties) {<a name="line.88"></a>
<span class="sourceLineNo">089</span>        if (properties != null) {<a name="line.89"></a>
<span class="sourceLineNo">090</span>            Properties temp = (Properties) properties.clone();<a name="line.90"></a>
<span class="sourceLineNo">091</span>            temp.remove("user");<a name="line.91"></a>
<span class="sourceLineNo">092</span>            temp.remove("password");<a name="line.92"></a>
<span class="sourceLineNo">093</span>            return temp;<a name="line.93"></a>
<span class="sourceLineNo">094</span>        }<a name="line.94"></a>
<span class="sourceLineNo">095</span>        return properties;<a name="line.95"></a>
<span class="sourceLineNo">096</span>    }<a name="line.96"></a>
<span class="sourceLineNo">097</span><a name="line.97"></a>
<span class="sourceLineNo">098</span>    /**<a name="line.98"></a>
<span class="sourceLineNo">099</span>     * Closes the AutoCloseable (which may be null).<a name="line.99"></a>
<span class="sourceLineNo">100</span>     *<a name="line.100"></a>
<span class="sourceLineNo">101</span>     * @param autoCloseable an AutoCloseable, may be {@code null}<a name="line.101"></a>
<span class="sourceLineNo">102</span>     * @since 2.6.0<a name="line.102"></a>
<span class="sourceLineNo">103</span>     */<a name="line.103"></a>
<span class="sourceLineNo">104</span>    public static void closeQuietly(final AutoCloseable autoCloseable) {<a name="line.104"></a>
<span class="sourceLineNo">105</span>        if (autoCloseable != null) {<a name="line.105"></a>
<span class="sourceLineNo">106</span>            try {<a name="line.106"></a>
<span class="sourceLineNo">107</span>                autoCloseable.close();<a name="line.107"></a>
<span class="sourceLineNo">108</span>            } catch (final Exception e) {<a name="line.108"></a>
<span class="sourceLineNo">109</span>                // ignored<a name="line.109"></a>
<span class="sourceLineNo">110</span>            }<a name="line.110"></a>
<span class="sourceLineNo">111</span>        }<a name="line.111"></a>
<span class="sourceLineNo">112</span>    }<a name="line.112"></a>
<span class="sourceLineNo">113</span><a name="line.113"></a>
<span class="sourceLineNo">114</span>    /**<a name="line.114"></a>
<span class="sourceLineNo">115</span>     * Closes the Connection (which may be null).<a name="line.115"></a>
<span class="sourceLineNo">116</span>     *<a name="line.116"></a>
<span class="sourceLineNo">117</span>     * @param connection a Connection, may be {@code null}<a name="line.117"></a>
<span class="sourceLineNo">118</span>     * @deprecated Use {@link #closeQuietly(AutoCloseable)}.<a name="line.118"></a>
<span class="sourceLineNo">119</span>     */<a name="line.119"></a>
<span class="sourceLineNo">120</span>    @Deprecated<a name="line.120"></a>
<span class="sourceLineNo">121</span>    public static void closeQuietly(final Connection connection) {<a name="line.121"></a>
<span class="sourceLineNo">122</span>        if (connection != null) {<a name="line.122"></a>
<span class="sourceLineNo">123</span>            try {<a name="line.123"></a>
<span class="sourceLineNo">124</span>                connection.close();<a name="line.124"></a>
<span class="sourceLineNo">125</span>            } catch (final Exception e) {<a name="line.125"></a>
<span class="sourceLineNo">126</span>                // ignored<a name="line.126"></a>
<span class="sourceLineNo">127</span>            }<a name="line.127"></a>
<span class="sourceLineNo">128</span>        }<a name="line.128"></a>
<span class="sourceLineNo">129</span>    }<a name="line.129"></a>
<span class="sourceLineNo">130</span><a name="line.130"></a>
<span class="sourceLineNo">131</span>    /**<a name="line.131"></a>
<span class="sourceLineNo">132</span>     * Closes the ResultSet (which may be null).<a name="line.132"></a>
<span class="sourceLineNo">133</span>     *<a name="line.133"></a>
<span class="sourceLineNo">134</span>     * @param resultSet a ResultSet, may be {@code null}<a name="line.134"></a>
<span class="sourceLineNo">135</span>     * @deprecated Use {@link #closeQuietly(AutoCloseable)}.<a name="line.135"></a>
<span class="sourceLineNo">136</span>     */<a name="line.136"></a>
<span class="sourceLineNo">137</span>    @Deprecated<a name="line.137"></a>
<span class="sourceLineNo">138</span>    public static void closeQuietly(final ResultSet resultSet) {<a name="line.138"></a>
<span class="sourceLineNo">139</span>        if (resultSet != null) {<a name="line.139"></a>
<span class="sourceLineNo">140</span>            try {<a name="line.140"></a>
<span class="sourceLineNo">141</span>                resultSet.close();<a name="line.141"></a>
<span class="sourceLineNo">142</span>            } catch (final Exception e) {<a name="line.142"></a>
<span class="sourceLineNo">143</span>                // ignored<a name="line.143"></a>
<span class="sourceLineNo">144</span>            }<a name="line.144"></a>
<span class="sourceLineNo">145</span>        }<a name="line.145"></a>
<span class="sourceLineNo">146</span>    }<a name="line.146"></a>
<span class="sourceLineNo">147</span><a name="line.147"></a>
<span class="sourceLineNo">148</span>    /**<a name="line.148"></a>
<span class="sourceLineNo">149</span>     * Closes the Statement (which may be null).<a name="line.149"></a>
<span class="sourceLineNo">150</span>     *<a name="line.150"></a>
<span class="sourceLineNo">151</span>     * @param statement a Statement, may be {@code null}.<a name="line.151"></a>
<span class="sourceLineNo">152</span>     * @deprecated Use {@link #closeQuietly(AutoCloseable)}.<a name="line.152"></a>
<span class="sourceLineNo">153</span>     */<a name="line.153"></a>
<span class="sourceLineNo">154</span>    @Deprecated<a name="line.154"></a>
<span class="sourceLineNo">155</span>    public static void closeQuietly(final Statement statement) {<a name="line.155"></a>
<span class="sourceLineNo">156</span>        if (statement != null) {<a name="line.156"></a>
<span class="sourceLineNo">157</span>            try {<a name="line.157"></a>
<span class="sourceLineNo">158</span>                statement.close();<a name="line.158"></a>
<span class="sourceLineNo">159</span>            } catch (final Exception e) {<a name="line.159"></a>
<span class="sourceLineNo">160</span>                // ignored<a name="line.160"></a>
<span class="sourceLineNo">161</span>            }<a name="line.161"></a>
<span class="sourceLineNo">162</span>        }<a name="line.162"></a>
<span class="sourceLineNo">163</span>    }<a name="line.163"></a>
<span class="sourceLineNo">164</span><a name="line.164"></a>
<span class="sourceLineNo">165</span>    /**<a name="line.165"></a>
<span class="sourceLineNo">166</span>     * Gets the correct i18n message for the given key.<a name="line.166"></a>
<span class="sourceLineNo">167</span>     *<a name="line.167"></a>
<span class="sourceLineNo">168</span>     * @param key The key to look up an i18n message.<a name="line.168"></a>
<span class="sourceLineNo">169</span>     * @return The i18n message.<a name="line.169"></a>
<span class="sourceLineNo">170</span>     */<a name="line.170"></a>
<span class="sourceLineNo">171</span>    public static String getMessage(final String key) {<a name="line.171"></a>
<span class="sourceLineNo">172</span>        return getMessage(key, (Object[]) null);<a name="line.172"></a>
<span class="sourceLineNo">173</span>    }<a name="line.173"></a>
<span class="sourceLineNo">174</span><a name="line.174"></a>
<span class="sourceLineNo">175</span>    /**<a name="line.175"></a>
<span class="sourceLineNo">176</span>     * Gets the correct i18n message for the given key with placeholders replaced by the supplied arguments.<a name="line.176"></a>
<span class="sourceLineNo">177</span>     *<a name="line.177"></a>
<span class="sourceLineNo">178</span>     * @param key A message key.<a name="line.178"></a>
<span class="sourceLineNo">179</span>     * @param args The message arguments.<a name="line.179"></a>
<span class="sourceLineNo">180</span>     * @return An i18n message.<a name="line.180"></a>
<span class="sourceLineNo">181</span>     */<a name="line.181"></a>
<span class="sourceLineNo">182</span>    public static String getMessage(final String key, final Object... args) {<a name="line.182"></a>
<span class="sourceLineNo">183</span>        final String msg = messages.getString(key);<a name="line.183"></a>
<span class="sourceLineNo">184</span>        if (args == null || args.length == 0) {<a name="line.184"></a>
<span class="sourceLineNo">185</span>            return msg;<a name="line.185"></a>
<span class="sourceLineNo">186</span>        }<a name="line.186"></a>
<span class="sourceLineNo">187</span>        final MessageFormat mf = new MessageFormat(msg);<a name="line.187"></a>
<span class="sourceLineNo">188</span>        return mf.format(args, new StringBuffer(), null).toString();<a name="line.188"></a>
<span class="sourceLineNo">189</span>    }<a name="line.189"></a>
<span class="sourceLineNo">190</span><a name="line.190"></a>
<span class="sourceLineNo">191</span>    /**<a name="line.191"></a>
<span class="sourceLineNo">192</span>     * Converts the given String to a char[].<a name="line.192"></a>
<span class="sourceLineNo">193</span>     *<a name="line.193"></a>
<span class="sourceLineNo">194</span>     * @param value may be null.<a name="line.194"></a>
<span class="sourceLineNo">195</span>     * @return a char[] or null.<a name="line.195"></a>
<span class="sourceLineNo">196</span>     */<a name="line.196"></a>
<span class="sourceLineNo">197</span>    public static char[] toCharArray(final String value) {<a name="line.197"></a>
<span class="sourceLineNo">198</span>        return value != null ? value.toCharArray() : null;<a name="line.198"></a>
<span class="sourceLineNo">199</span>    }<a name="line.199"></a>
<span class="sourceLineNo">200</span><a name="line.200"></a>
<span class="sourceLineNo">201</span>    /**<a name="line.201"></a>
<span class="sourceLineNo">202</span>     * Converts the given char[] to a String.<a name="line.202"></a>
<span class="sourceLineNo">203</span>     *<a name="line.203"></a>
<span class="sourceLineNo">204</span>     * @param value may be null.<a name="line.204"></a>
<span class="sourceLineNo">205</span>     * @return a String or null.<a name="line.205"></a>
<span class="sourceLineNo">206</span>     */<a name="line.206"></a>
<span class="sourceLineNo">207</span>    public static String toString(final char[] value) {<a name="line.207"></a>
<span class="sourceLineNo">208</span>        return value == null ? null : String.valueOf(value);<a name="line.208"></a>
<span class="sourceLineNo">209</span>    }<a name="line.209"></a>
<span class="sourceLineNo">210</span><a name="line.210"></a>
<span class="sourceLineNo">211</span>    private Utils() {<a name="line.211"></a>
<span class="sourceLineNo">212</span>        // not instantiable<a name="line.212"></a>
<span class="sourceLineNo">213</span>    }<a name="line.213"></a>
<span class="sourceLineNo">214</span><a name="line.214"></a>
<span class="sourceLineNo">215</span>}<a name="line.215"></a>




























































</pre>
</div>
</body>
</html>
